package search.basic;

public class Algorithms {

	/** Main method */
	public static void main(String[] args) {
		// Linear search
		int [] array = new int[] {5, 6, 3, 1, 8, 9, 0, 2, 4, 1, 7};		
		System.out.println("\nLinear search");
		System.out.println(linearSearch(array, 1));

		// Binary search
		int [] ordered = new int[] {1, 2, 3, 4, 5, 6, 7, 8, 9, 10};
		System.out.println("\nBinary search");
		System.out.println(binarySearch(ordered, 11));		
	}

	/** Linear search 
	 * @param list Sequence of elements
	 * @param e Element to find
	 * @return Position of e in list; -1 if not found */

	public static int linearSearch(int [] list, int e) {
		int location = -1;
		boolean found = false;

		for(int i=0; i<list.length && !found; i++)
			if(list[i] == e) {
				location = i;
				found = true;
			}

		return location;
	}

	/** Binary search 
	 * @param list Ordered sequence of elements 
	 * @param e Element to find 
	 * @return Position of e in list; -1 if not found */

	public static int binarySearch(int [] list, int e) {
		int location = -1;
		int left   = 0;
		int right  = list.length - 1;
		int middle = list.length / 2;
		boolean found = false;

		while(left <= right && !found) {
			if(e == list[middle]) {
				found = true;
				location = middle;
			} else if(e < list[middle]) {
				right = middle-1;
			} else {
				left  = middle+1;
			}
			middle = (right+left) / 2;				
		}

		return location;		
	}
}
