package sorting.basic;

public class Algorithms {
	
	/** Main method */
	public static void main(String[] args) {
		// Bubble sort
		int [] array = new int[] {5, 6, 3, 1, 8, 9, 0, 2, 4, 1, 7};
		System.out.println("\nBubble sort");
		Algorithms.bubbleSort(array);
		Algorithms.print(array);
		
		// Selection sort
		array = new int[] {5, 6, 3, 1, 8, 9, 0, 2, 4, 1, 7};
		System.out.println("\nSelection sort");
		Algorithms.selectionSort(array);
		Algorithms.print(array);
		
		// Insertion sort
		array = new int[] {5, 6, 3, 1, 8, 9, 0, 2, 4, 1, 7};
		System.out.println("\nInsertion sort");
		Algorithms.insertionSort(array);
		Algorithms.print(array);
	}
	
	/** Bubble sort 
	 * @param list Array to sort */
	public static void bubbleSort(int [] list) {
		boolean swapped;
		
		do {
			swapped = false;
			
			for(int i=0; i <= list.length-2; i++) {
				if(list[i] > list[i+1]) {
					int temp = list[i];
					list[i] = list[i+1];
					list[i+1] = temp;
					
					swapped = true;
				}				
			}
			
		} while(swapped);
	}
	
	
	/** Selection sort 
	 * @param list Array to sort */
	public static void selectionSort(int [] list) {
		
		for(int i=0; i <= list.length-2; i++) {
			int minPos = i;
			
			for(int j=i+1; j < list.length; j++)
				if(list[j] < list[minPos])
					minPos = j;
			
			int temp = list[i];
			list[i] = list[minPos];
			list[minPos] = temp;
		}
	}
	
	/** Insertion sort 
	 * @param list Array to sort */
	public static void insertionSort(int [] list) {
		
		for(int i=1; i < list.length; i++) {
			int e = list[i];
			int j = i-1;
			
			while(j>=0 && list[j] > e) {
				list[j+1] = list[j];
				j--;
			}
			
			list[j+1] = e;
		}
	}
	
	/** Print array 
	 * @param list Array */
	public static void print(int [] list) {
		System.out.print("[");
		for(int i=0; i<list.length; i++)
			System.out.print(list[i] + " ");
		System.out.println("]");
	}
	
	/** Random initialization 
	 * @param list Array */
	public static void init(int [] list) {
		for(int i=0; i < list.length; i++)
			list[i] =(int) (Math.random() * 10);
	}

}
